## duckstation 0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(duckstation C CXX)

# Policy settings.
cmake_policy(SET CMP0069 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)

message(STATUS "CMake Version: ${CMAKE_VERSION}")
message(STATUS "CMake System Name: ${CMAKE_SYSTEM_NAME}")
message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")

# Pull in modules.
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/CMakeModules/")
include(DuckStationUtils)

# Platform detection.
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  set(LINUX TRUE)
elseif(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
  set(FREEBSD TRUE)
endif()

# Renderer options.
option(ENABLE_OPENGL "Build with OpenGL renderer" ON)
option(ENABLE_VULKAN "Build with Vulkan renderer" ON)

# Global options.
if(NOT ANDROID)
  option(BUILD_NOGUI_FRONTEND "Build the NoGUI frontend" OFF)
  option(BUILD_QT_FRONTEND "Build the Qt frontend" ON)
  option(BUILD_REGTEST "Build regression test runner" OFF)
  option(BUILD_TESTS "Build unit tests" OFF)

  set(ENABLE_CUBEB ON)
  set(ENABLE_DISCORD_PRESENCE ON)
  set(ENABLE_SDL2 ON)

  if(LINUX OR FREEBSD)
    option(ENABLE_X11 "Support X11 window system" ON)
    option(ENABLE_WAYLAND "Support Wayland window system" ON)
  endif()
  if(APPLE)
    option(SKIP_POSTPROCESS_BUNDLE "Disable bundle post-processing, including Qt additions" OFF)
  endif()
endif()

# Everything except Windows/Mac use EGL.
if(ENABLE_OPENGL AND (LINUX OR FREEBSD OR ANDROID))
  set(ENABLE_EGL TRUE)
endif()

if(ENABLE_X11)
  find_package(X11 REQUIRED)
  if (NOT X11_Xrandr_FOUND)
    message(FATAL_ERROR "XRandR extension is required")
  endif()
endif()
if(ENABLE_WAYLAND)
  message(STATUS "Wayland support enabled")
endif()


# Set _DEBUG macro for Debug builds.
set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -D_DEBUG")
set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -D_DEBUG")


# Release build optimizations for MSVC.
if(MSVC)
  add_definitions("/D_CRT_SECURE_NO_WARNINGS")
  foreach(config CMAKE_C_FLAGS CMAKE_CXX_FLAGS)
    # Set warning level 3 instead of 4.
    string(REPLACE "/W3" "/W4" ${config} "${${config}}")

    # Enable intrinsic functions, disable minimal rebuild, UTF-8 source, set __cplusplus version.
    set(${config} "${${config}} /Oi /Gm- /utf-8 /Zc:__cplusplus")
  endforeach()

  # RelWithDebInfo is set to Ob1 instead of Ob2.   
  string(REPLACE "/Ob1" "/Ob2" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
  string(REPLACE "/Ob1" "/Ob2" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")

  # Disable incremental linking in RelWithDebInfo.
  string(REPLACE "/INCREMENTAL" "/INCREMENTAL:NO" CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO}")

  # COMDAT folding/remove unused functions.
  set(CMAKE_EXE_LINKER_FLAGS_RELEASE "${CMAKE_EXE_LINKER_FLAGS_RELEASE} /OPT:REF /OPT:ICF")
  set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO} /OPT:REF /OPT:ICF")
endif()


# Default symbol visibility to hidden, that way we don't go through the PLT for intra-library calls.
if(ANDROID)
  cmake_policy(SET CMP0063 NEW)
  set(CMAKE_POLICY_DEFAULT_CMP0063 NEW)
  set(CMAKE_C_VISIBILITY_PRESET hidden)
  set(CMAKE_CXX_VISIBILITY_PRESET hidden)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-semantic-interposition")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-semantic-interposition")
endif()


# Warning disables.
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    include(CheckCXXFlag)
    check_cxx_flag(-Wall COMPILER_SUPPORTS_WALL)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-switch")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-switch")
    if(NOT ANDROID)
      check_cxx_flag(-Wno-class-memaccess COMPILER_SUPPORTS_MEMACCESS)
      check_cxx_flag(-Wno-invalid-offsetof COMPILER_SUPPORTS_OFFSETOF)
    endif()
endif()


# Detect processor type.
if(APPLE AND NOT "${CMAKE_OSX_ARCHITECTURES}" STREQUAL "")
  # Universal binaries.
  if("x86_64" IN_LIST CMAKE_OSX_ARCHITECTURES)
    set(CPU_ARCH_X64 TRUE)
    message(STATUS "Building x86_64 MacOS binaries.")
  endif()
  if("arm64" IN_LIST CMAKE_OSX_ARCHITECTURES)
    set(CPU_ARCH_ARM64 TRUE)
    message(STATUS "Building ARM64 MacOS binaries.")
  endif()
elseif("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64" OR "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "amd64" OR
       "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "AMD64" OR "${CMAKE_OSX_ARCHITECTURES}" STREQUAL "x86_64")
  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(CPU_ARCH_X64 TRUE)
    message(STATUS "Building x86_64 binaries.")
  else()
    # Cross-compiling 32-bit build. 32-bit hosts are not supported.
    set(CPU_ARCH_X86 TRUE)
    message(FATAL_ERROR "Building x86_32 binaries is not supported.")
  endif()
elseif("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86" OR "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "i386" OR
       "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "i686")
  set(CPU_ARCH_X86 TRUE)
  message(FATAL_ERROR "Building x86_32 binaries is not supported.")
elseif("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "aarch64" OR "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "arm64")
  if(CMAKE_SIZEOF_VOID_P EQUAL 8) # Might have an A64 kernel, e.g. Raspbian.
    set(CPU_ARCH_ARM64 TRUE)
    message(STATUS "Building ARM64 binaries.")
  else()
    set(CPU_ARCH_ARM32 TRUE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -marm -march=armv7-a")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -marm -march=armv7-a")
    message(STATUS "Building ARM32 binaries on ARM64.")
  endif()
elseif("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "arm" OR "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "armv7-a" OR
       "${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "armv7l")
  set(CPU_ARCH_ARM32 TRUE)
  message(STATUS "Building ARM32 binaries.")
  if(ANDROID)
    # Force ARM mode, since apparently ANDROID_ARM_MODE isn't working..
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -marm")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -marm")
  else()
    # Enable NEON.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -marm -march=armv7-a")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -marm -march=armv7-a")
  endif()
elseif("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "riscv64")
  set(CPU_ARCH_RISCV64 TRUE)
  message(STATUS "Building RISC-V 64 binaries.")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -finline-atomics")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -finline-atomics")

  # Still need this, apparently.
  link_libraries("-latomic")

  if(NOT "${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    # Frame pointers generate an annoying amount of code on leaf functions.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fomit-frame-pointer")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fomit-frame-pointer")
  endif()
else()
  message(FATAL_ERROR "Unknown system processor: ${CMAKE_SYSTEM_PROCESSOR}")
endif()

# Detect page size if needed.
detect_page_size()


# We don't need exceptions, disable them to save a bit of code size.
if(MSVC)
  string(REPLACE "/EHsc" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  string(REPLACE "/GR" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")

  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /D_HAS_EXCEPTIONS=0 /permissive-")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-exceptions -fno-rtti")
endif()


# Write binaries to a seperate directory.
if(WIN32)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/bin/${CPU_ARCH}")
else()
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/bin")
endif()

# Needed for Linux - put shared libraries in the binary directory.
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")


# Enable threads everywhere.
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)


# Enable large file support on Linux 32-bit platforms.
# Android is deliberately ommitted here as it didn't support 64-bit ops on files until Android 7/N.
if((LINUX OR FREEBSD) AND (CPU_ARCH_X86 OR CPU_ARCH_ARM32))
  add_definitions("-D_FILE_OFFSET_BITS=64")
endif()

if(BUILD_TESTS)
  enable_testing()
endif()

# Prevent fmt from being built with exceptions, or being thrown at call sites.
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DFMT_EXCEPTIONS=0")

# Use C++17 for building dependencies (some aren't C++20-aware, e.g. reshadefx).
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Recursively include the source tree.
include(DuckStationDependencies)
add_subdirectory(dep)

# Use C++20 for building the main libraries.
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
add_subdirectory(src)

if(ANDROID)
  add_subdirectory(android/app/src/cpp)
endif()

=== dep/CMakeLists.txt ===
set(FMT_INSTALL OFF CACHE BOOL "")
add_subdirectory(fmt EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(fmt)
add_subdirectory(minizip EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(minizip)
add_subdirectory(lzma EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(lzma)
add_subdirectory(libchdr EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(libchdr)
add_subdirectory(xxhash EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(xxhash)
add_subdirectory(rapidjson EXCLUDE_FROM_ALL)
add_subdirectory(glslang EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(glslang)
add_subdirectory(imgui EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(imgui)
add_subdirectory(simpleini EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(simpleini)
add_subdirectory(vulkan EXCLUDE_FROM_ALL)
add_subdirectory(soundtouch EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(soundtouch)
add_subdirectory(googletest EXCLUDE_FROM_ALL)
add_subdirectory(cpuinfo EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(cpuinfo)
add_subdirectory(fast_float EXCLUDE_FROM_ALL)
add_subdirectory(reshadefx EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(reshadefx)
add_subdirectory(rcheevos EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(rcheevos)
add_subdirectory(rapidyaml EXCLUDE_FROM_ALL)
disable_compiler_warnings_for_target(rapidyaml)

# Build dependencies on Windows/Android.
if(WIN32 OR ANDROID)
  add_subdirectory(zlib EXCLUDE_FROM_ALL)
  add_subdirectory(zstd EXCLUDE_FROM_ALL)
  add_subdirectory(libpng EXCLUDE_FROM_ALL)
  add_subdirectory(libjpeg EXCLUDE_FROM_ALL)
endif()

if(ENABLE_CUBEB)
  add_subdirectory(cubeb EXCLUDE_FROM_ALL)
  disable_compiler_warnings_for_target(cubeb)
  disable_compiler_warnings_for_target(speex)
endif()

if(ENABLE_OPENGL)
  add_subdirectory(glad EXCLUDE_FROM_ALL)
  disable_compiler_warnings_for_target(glad)
endif()

if(ENABLE_DISCORD_PRESENCE)
  add_subdirectory(discord-rpc EXCLUDE_FROM_ALL)
  disable_compiler_warnings_for_target(discord-rpc)
endif()

if(CPU_ARCH_X64)
  add_subdirectory(xbyak EXCLUDE_FROM_ALL)
  add_subdirectory(zydis EXCLUDE_FROM_ALL)
  disable_compiler_warnings_for_target(zydis)
endif()

if(CPU_ARCH_ARM32 OR CPU_ARCH_ARM64)
  add_subdirectory(vixl EXCLUDE_FROM_ALL)
  disable_compiler_warnings_for_target(vixl)
endif()

if(CPU_ARCH_RISCV64)
  add_subdirectory(biscuit EXCLUDE_FROM_ALL)
  disable_compiler_warnings_for_target(biscuit)
  add_subdirectory(riscv-disas EXCLUDE_FROM_ALL)
  disable_compiler_warnings_for_target(riscv-disas)
endif()

if(WIN32)
  add_subdirectory(d3d12ma EXCLUDE_FROM_ALL)
  disable_compiler_warnings_for_target(d3d12ma)
  add_subdirectory(winpixeventruntime EXCLUDE_FROM_ALL)
endif()

if(APPLE)
  add_subdirectory(spirv-cross EXCLUDE_FROM_ALL)
  disable_compiler_warnings_for_target(spirv-cross)
endif()

=== dep/glad/CMakeLists.txt ===
set(SRCS
  include/glad/gl.h
  include/KHR/khrplatform.h
  src/gl.c
)

# Linking as a static library breaks on macOS, see https://github.com/libigl/libigl/issues/751
if(APPLE)
  add_library(glad OBJECT ${SRCS})
else()
  add_library(glad ${SRCS})
endif()

target_include_directories(glad PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/include")
target_link_libraries(glad PRIVATE Threads::Threads "${CMAKE_DL_LIBS}")

if(WIN32)
  target_sources(glad PRIVATE
    include/glad/wgl.h
    src/wgl.c
  )
else()
  if(ENABLE_EGL)
    target_sources(glad PRIVATE
      include/EGL/eglplatform.h
      include/glad/egl.h
      src/egl.c
    )
  endif()
endif()

=== dep/imgui/CMakeLists.txt ===
set(SRCS
  include/imconfig.h
  include/imgui.h
  include/imgui_freetype.h
  include/imgui_internal.h
  include/imgui_stdlib.h
  include/imstb_textedit.h
  src/imgui.cpp
  src/imgui_demo.cpp
  src/imgui_draw.cpp
  src/imgui_freetype.cpp
  src/imgui_stdlib.cpp
  src/imgui_tables.cpp
  src/imgui_widgets.cpp
  src/imstb_rectpack.h
  src/imstb_truetype.h
)

add_library(imgui ${SRCS})
target_include_directories(imgui PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/include" "${CMAKE_CURRENT_SOURCE_DIR}/src")
target_include_directories(imgui INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/include")
target_link_libraries(imgui PUBLIC Freetype::Freetype lunasvg::lunasvg)

=== dep/lzma/CMakeLists.txt ===
add_library(lzma
  include/7zTypes.h
  include/Alloc.h
  include/Bra.h
  include/Compiler.h
  include/CpuArch.h
  include/Delta.h
  include/LzFind.h
  include/LzHash.h
  include/Lzma86.h
  include/LzmaDec.h
  include/LzmaEnc.h
  include/LzmaLib.h
  include/Precomp.h
  include/Sort.h
  src/Alloc.c
  src/Bra86.c
  src/BraIA64.c
  src/CpuArch.c
  src/Delta.c
  src/LzFind.c
  src/Lzma86Dec.c
  src/Lzma86Enc.c
  src/LzmaDec.c
  src/LzmaEnc.c
  src/LzmaLib.c
  src/Sort.c
)

target_compile_definitions(lzma PRIVATE _7ZIP_ST)

target_include_directories(lzma PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/include")
target_include_directories(lzma INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/include")

=== dep/rapidyaml/CMakeLists.txt ===
add_library(rapidyaml
  include/c4/base64.hpp
  include/c4/blob.hpp
  include/c4/charconv.hpp
  include/c4/compiler.hpp
  include/c4/config.hpp
  include/c4/cpu.hpp
  include/c4/dump.hpp
  include/c4/error.hpp
  include/c4/export.hpp
  include/c4/format.hpp
  include/c4/language.hpp
  include/c4/memory_util.hpp
  include/c4/platform.hpp
  include/c4/preprocessor.hpp
  include/c4/std/std.hpp
  include/c4/std/std_fwd.hpp
  include/c4/std/string.hpp
  include/c4/std/string_fwd.hpp
  include/c4/std/string_view.hpp
  include/c4/std/tuple.hpp
  include/c4/std/vector.hpp
  include/c4/std/vector_fwd.hpp
  include/c4/substr.hpp
  include/c4/substr_fwd.hpp
  include/c4/szconv.hpp
  include/c4/types.hpp
  include/c4/utf.hpp
  include/c4/windows.hpp
  include/c4/windows_pop.hpp
  include/c4/windows_push.hpp
  include/c4/yml/common.hpp
  include/c4/yml/detail/parser_dbg.hpp
  include/c4/yml/detail/stack.hpp
  include/c4/yml/emit.def.hpp
  include/c4/yml/emit.hpp
  include/c4/yml/export.hpp
  include/c4/yml/node.hpp
  include/c4/yml/parse.hpp
  include/c4/yml/preprocess.hpp
  include/c4/yml/std/map.hpp
  include/c4/yml/std/std.hpp
  include/c4/yml/std/string.hpp
  include/c4/yml/std/vector.hpp
  include/c4/yml/tree.hpp
  include/c4/yml/writer.hpp
  include/c4/yml/yml.hpp
  include/ryml.hpp
  include/ryml_std.hpp
  src/c4/base64.cpp
  src/c4/error.cpp
  src/c4/format.cpp
  src/c4/language.cpp
  src/c4/memory_util.cpp
  src/c4/utf.cpp
  src/c4/yml/common.cpp
  src/c4/yml/node.cpp
  src/c4/yml/parse.cpp
  src/c4/yml/preprocess.cpp
  src/c4/yml/tree.cpp
)

target_include_directories(rapidyaml PRIVATE
  "${CMAKE_CURRENT_SOURCE_DIR}/include"
  "${CMAKE_CURRENT_SOURCE_DIR}/src"
  "${CMAKE_CURRENT_SOURCE_DIR}/../fast_float/include"
)
target_include_directories(rapidyaml INTERFACE
  "${CMAKE_CURRENT_SOURCE_DIR}/include"
)

target_compile_definitions(rapidyaml PUBLIC
  "C4_NO_DEBUG_BREAK"
)

=== dep/rcheevos/CMakeLists.txt ===
add_library(rcheevos
  include/rcheevos.h
  include/rc_api_editor.h
  include/rc_api_info.h
  include/rc_api_request.h
  include/rc_api_runtime.h
  include/rc_api_user.h
  include/rc_client.h
  include/rc_consoles.h
  include/rc_error.h
  include/rc_hash.h
  include/rc_runtime.h
  include/rc_runtime_types.h
  include/rc_url.h
  include/rc_util.h
  src/rapi/rc_api_common.c
  src/rapi/rc_api_common.h
  src/rapi/rc_api_editor.c
  src/rapi/rc_api_info.c
  src/rapi/rc_api_runtime.c
  src/rapi/rc_api_user.c
  src/rcheevos/alloc.c
  src/rcheevos/condition.c
  src/rcheevos/condset.c
  src/rcheevos/consoleinfo.c
  src/rcheevos/format.c
  src/rcheevos/lboard.c
  src/rcheevos/memref.c
  src/rcheevos/operand.c
  src/rcheevos/rc_internal.h
  src/rcheevos/richpresence.c
  src/rcheevos/runtime.c
  src/rcheevos/runtime_progress.c
  src/rcheevos/trigger.c
  src/rcheevos/value.c
  src/rc_client.c
  src/rc_client_internal.h
  src/rc_compat.c
  src/rc_compat.h
  src/rc_util.c
  src/rc_version.h
  src/rhash/md5.c
  src/rhash/md5.h
  src/rurl/url.c
)

target_include_directories(rcheevos PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/include")
target_include_directories(rcheevos INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/include")
target_compile_definitions(rcheevos PRIVATE "RC_DISABLE_LUA=1" "RCHEEVOS_URL_SSL=1" "RC_NO_THREADS=1")

=== dep/reshadefx/CMakeLists.txt ===
add_library(reshadefx
  include/effect_codegen.hpp
  include/effect_expression.hpp
  include/effect_lexer.hpp
  include/effect_module.hpp
  include/effect_parser.hpp
  include/effect_preprocessor.hpp
  include/effect_symbol_table.hpp
  include/effect_token.hpp
  src/effect_codegen_glsl.cpp
  src/effect_codegen_hlsl.cpp
  src/effect_codegen_spirv.cpp
  src/effect_expression.cpp
  src/effect_lexer.cpp
  src/effect_parser_exp.cpp
  src/effect_parser_stmt.cpp
  src/effect_preprocessor.cpp
  src/effect_symbol_table.cpp
)

target_include_directories(reshadefx PRIVATE
  "${CMAKE_CURRENT_SOURCE_DIR}/include"
  "${CMAKE_CURRENT_SOURCE_DIR}/src"
  "${CMAKE_CURRENT_SOURCE_DIR}/../spirv-cross/include/spirv-cross" # SPIR-V
)
target_include_directories(reshadefx INTERFACE
  "${CMAKE_CURRENT_SOURCE_DIR}/include"
)

=== dep/vixl/CMakeLists.txt ===
add_library(vixl
  include/vixl/assembler-base-vixl.h
  include/vixl/code-buffer-vixl.h
  include/vixl/code-generation-scopes-vixl.h
  include/vixl/compiler-intrinsics-vixl.h
  include/vixl/cpu-features.h
  include/vixl/globals-vixl.h
  include/vixl/invalset-vixl.h
  include/vixl/macro-assembler-interface.h
  include/vixl/platform-vixl.h
  include/vixl/pool-manager-impl.h
  include/vixl/pool-manager.h
  include/vixl/utils-vixl.h
  src/code-buffer-vixl.cc
  src/compiler-intrinsics-vixl.cc
  src/cpu-features.cc
  src/utils-vixl.cc
)

target_include_directories(vixl PUBLIC
  ${CMAKE_CURRENT_SOURCE_DIR}/include
)
target_include_directories(vixl PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/include/vixl
)
target_compile_definitions(vixl PUBLIC
  VIXL_CODE_BUFFER_MALLOC
)

if(CPU_ARCH_ARM32)
  target_sources(vixl PRIVATE
    include/vixl/aarch32/assembler-aarch32.h
    include/vixl/aarch32/constants-aarch32.h
    include/vixl/aarch32/disasm-aarch32.h
    include/vixl/aarch32/instructions-aarch32.h
    include/vixl/aarch32/location-aarch32.h
    include/vixl/aarch32/macro-assembler-aarch32.h
    include/vixl/aarch32/operands-aarch32.h
    src/aarch32/assembler-aarch32.cc
    src/aarch32/constants-aarch32.cc
    src/aarch32/disasm-aarch32.cc
    src/aarch32/instructions-aarch32.cc
    src/aarch32/location-aarch32.cc
    src/aarch32/macro-assembler-aarch32.cc
    src/aarch32/operands-aarch32.cc
  )
  target_include_directories(vixl PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/include/vixl/aarch32
  )
  target_compile_definitions(vixl PUBLIC
    VIXL_INCLUDE_TARGET_A32
  )
endif()

if(CPU_ARCH_ARM64)
  target_sources(vixl PRIVATE
    include/vixl/aarch64/abi-aarch64.h
    include/vixl/aarch64/assembler-aarch64.h
    include/vixl/aarch64/constants-aarch64.h
    include/vixl/aarch64/cpu-aarch64.h
    include/vixl/aarch64/cpu-features-auditor-aarch64.h
    include/vixl/aarch64/debugger-aarch64.h
    include/vixl/aarch64/decoder-aarch64.h
    include/vixl/aarch64/decoder-constants-aarch64.h
    include/vixl/aarch64/decoder-visitor-map-aarch64.h
    include/vixl/aarch64/disasm-aarch64.h
    include/vixl/aarch64/instructions-aarch64.h
    include/vixl/aarch64/macro-assembler-aarch64.h
    include/vixl/aarch64/operands-aarch64.h
    include/vixl/aarch64/registers-aarch64.h
    include/vixl/aarch64/simulator-aarch64.h
    include/vixl/aarch64/simulator-constants-aarch64.h
    src/aarch64/assembler-aarch64.cc
    src/aarch64/assembler-sve-aarch64.cc
    src/aarch64/cpu-aarch64.cc
    src/aarch64/cpu-features-auditor-aarch64.cc
    src/aarch64/decoder-aarch64.cc
    src/aarch64/disasm-aarch64.cc
    src/aarch64/instructions-aarch64.cc
    src/aarch64/logic-aarch64.cc
    src/aarch64/macro-assembler-aarch64.cc
    src/aarch64/macro-assembler-sve-aarch64.cc
    src/aarch64/operands-aarch64.cc
    src/aarch64/pointer-auth-aarch64.cc
    src/aarch64/registers-aarch64.cc
  )
  target_include_directories(vixl PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/include/vixl/aarch64
  )
  target_compile_definitions(vixl PUBLIC
    VIXL_INCLUDE_TARGET_A64
  )
endif()

# Currently disabled becuase the old rec sucks.
#if("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
#  message("Enabling vixl debug assertions")
#  target_compile_definitions(vixl PUBLIC VIXL_DEBUG)
#endif()

=== dep/xbyak/CMakeLists.txt ===
add_library(xbyak INTERFACE)
target_include_directories(xbyak INTERFACE "${CMAKE_CURRENT_SOURCE_DIR}/xbyak")
target_compile_definitions(xbyak INTERFACE "XBYAK_NO_EXCEPTION=1")

=== src/common-tests/CMakeLists.txt ===
add_executable(common-tests
  bitutils_tests.cpp
  file_system_tests.cpp
  gsvector_yuvtorgb_test.cpp
  path_tests.cpp
  rectangle_tests.cpp
  string_tests.cpp
)

target_link_libraries(common-tests PRIVATE common gtest gtest_main)

=== src/common/CMakeLists.txt ===
add_library(common
  align.h
  assert.cpp
  assert.h
  binary_reader_writer.cpp
  binary_reader_writer.h
  bitfield.h
  bitutils.h
  build_timestamp.h
  crash_handler.cpp
  crash_handler.h
  dimensional_array.h
  dynamic_library.cpp
  dynamic_library.h
  error.cpp
  error.h
  fastjmp.cpp
  fastjmp.h
  fifo_queue.h
  file_system.cpp
  file_system.h
  gsvector.cpp
  gsvector.h
  gsvector_formatter.h
  gsvector_neon.h
  gsvector_nosimd.h
  gsvector_sse.h
  intrin.h
  hash_combine.h
  heap_array.h
  heterogeneous_containers.h
  layered_settings_interface.cpp
  layered_settings_interface.h
  log.cpp
  log.h
  memmap.cpp
  memmap.h
  md5_digest.cpp
  md5_digest.h
  memory_settings_interface.cpp
  memory_settings_interface.h
  minizip_helpers.h
  path.h
  perf_scope.cpp
  perf_scope.h
  progress_callback.cpp
  progress_callback.h
  scoped_guard.h
  settings_interface.h
  sha1_digest.cpp
  sha1_digest.h
  small_string.cpp
  small_string.h
  string_util.cpp
  string_util.h
  thirdparty/SmallVector.cpp
  thirdparty/SmallVector.h
  threading.cpp
  threading.h
  timer.cpp
  timer.h
  types.h
)

target_include_directories(common PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/..")
target_include_directories(common PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/..")
target_link_libraries(common PUBLIC fmt Threads::Threads fast_float)
target_link_libraries(common PRIVATE "${CMAKE_DL_LIBS}")

if(WIN32)
  target_sources(common PRIVATE
    thirdparty/StackWalker.cpp
    thirdparty/StackWalker.h
    windows_headers.h
  )
  target_link_libraries(common PRIVATE OneCore.lib)
endif()

if(MSVC)
  if(CPU_ARCH_X64)
    enable_language(ASM_MASM)
    target_sources(common PRIVATE fastjmp_x86.asm)
    set_source_files_properties(fastjmp_x86.asm PROPERTIES COMPILE_FLAGS "/D_M_X86_64")
  elseif(CPU_ARCH_ARM32 OR CPU_ARCH_ARM64)
    enable_language(ASM_MARMASM)
    target_sources(common PRIVATE fastjmp_arm.asm)
  endif()
endif()

if(APPLE)
  set(MAC_SOURCES
    cocoa_tools.h
    cocoa_tools.mm
  )
  target_sources(common PRIVATE ${MAC_SOURCES})
  set_source_files_properties(${MAC_SOURCES} PROPERTIES SKIP_PRECOMPILE_HEADERS TRUE)
  find_library(COCOA_LIBRARY Cocoa REQUIRED)
  target_link_libraries(common PRIVATE ${COCOA_LIBRARY})
endif()

if(NOT WIN32 AND NOT ANDROID AND NOT APPLE)
  target_link_libraries(common PRIVATE libbacktrace::libbacktrace)
endif()

if(ANDROID)
  target_link_libraries(common PRIVATE log)
endif()

if(LINUX)
  # We need -lrt for shm_unlink
  target_link_libraries(common PRIVATE rt)
endif()

# If the host size was detected, we need to set it as a macro.
if(HOST_PAGE_SIZE)
  target_compile_definitions(common PUBLIC "-DOVERRIDE_HOST_PAGE_SIZE=${HOST_PAGE_SIZE}")
endif()
if(HOST_CACHE_LINE_SIZE)
	target_compile_definitions(common PUBLIC "-DOVERRIDE_HOST_CACHE_LINE_SIZE=${HOST_CACHE_LINE_SIZE}")
endif()

## duckstation 0.1-6461

=== debian/changelog ===
duckstation (0.1-6461-0+twolife2) unstable; urgency=low

  * Initial release.

 -- Sébastien Noel <sebastien@twolife.be>  Sat, 08 Jun 2024 21:41:01 +0200

=== debian/control ===
Source: duckstation
Section: games
Priority: optional
Maintainer: Sébastien Noel <sebastien@twolife.be>
Build-Depends: cmake,
  debhelper-compat (= 12),
  extra-cmake-modules,
  libcpuinfo-dev,
  libcubeb-dev,
  libcurl4-openssl-dev,
  libdrm-dev,
  libfmt-dev,
  libgbm-dev,
  glslang-dev,
  libasound2-dev,
  libgtest-dev,
  libicu-dev,
  libimgui-dev (>= 1.88),
  libjpeg-dev,
  libminizip-dev,
  libpng-dev,
  libpulse-dev,
  librcheevos-dev,
  libsdl2-dev,
  libsimpleini-dev,
  libsndio-dev,
  libstb-dev,
  libtinyxml2-dev,
  libvulkan-dev,
  libvulkan-memory-allocator-dev,
  libwebp-dev,
  libxxhash-dev,
  libzstd-dev,
  libzydis-dev,
  qt6-base-private-dev,
  qt6-tools-dev,
  rapidjson-dev,
  spirv-headers
Standards-Version: 4.6.2
Homepage: https://www.duckstation.org/

Package: duckstation
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt6svg6, duckstation-data (= ${source:Version})
Description: Sony PlayStation emulator
 DuckStation is an simulator/emulator of the Sony PlayStation(TM) console,
 focusing on playability, speed, and long-term maintainability.

Package: duckstation-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: duckstation
Description: Sony PlayStation emulator (data files)
 DuckStation is an simulator/emulator of the Sony PlayStation(TM) console,
 focusing on playability, speed, and long-term maintainability.
 .
 This package contains the platform independent data files for DuckStation.

#Package: libretro-duckstation
#Architecture: any
#Multi-Arch: same
#Depends: retroarch | libretro-frontend, ${misc:Depends}, ${shlibs:Depends}
#Description: Libretro wrapper for DuckStation
# This wrapper makes DuckStation API compatible with libretro, thus allowing
# its use with libretro frontends, such as RetroArch.
# .
# DuckStation is an simulator/emulator of the Sony PlayStation(TM) console,
# focusing on playability, speed, and long-term maintainability.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
#	dh_auto_configure --builddir=deblibretro -- -DENABLE_DISCORD_PRESENCE=OFF -DBUILD_LIBRETRO_CORE=ON
	dh_auto_configure --builddir=debqt6 -- -DUSE_WAYLAND=ON -DUSE_X11=ON -DENABLE_DISCORD_PRESENCE=OFF

override_dh_auto_build:
#	dh_auto_build --builddir=deblibretro
	dh_auto_build --builddir=debqt6

override_dh_auto_clean:
#	dh_auto_clean --builddir=deblibretro
	dh_auto_clean --builddir=debqt6

## duckstation 0.1-7465

=== debian/changelog ===
duckstation (0.1-7465-0+twolife2) unstable; urgency=low

  * Initial release. Maybe last release as the maintainers
    of DuckStation updated their license, changing it to the
    PolyForm Strict License 1.0.0, a non-free software license.

 -- Sébastien Noel <sebastien@twolife.be>  Wed, 06 Nov 2024 08:29:07 +0100

=== debian/control ===
Source: duckstation
Section: games
Priority: optional
Maintainer: Sébastien Noel <sebastien@twolife.be>
Build-Depends: cmake,
  debhelper-compat (= 12),
  extra-cmake-modules,
  libavcodec-dev, libavformat-dev, libavutil-dev, libswresample-dev, libswscale-dev,
  libasound2-dev,
  libbacktrace-dev,
  libcpuinfo-dev,
  libcubeb-dev,
  libcurl4-openssl-dev,
  libdiscord-rpc-dev,
  libdrm-dev,
  libfmt-dev,
  libgbm-dev,
  libgtest-dev,
  libicu-dev,
  libimgui-dev (>= 1.90.9),
  libjpeg-dev,
  libkissfft-dev,
  libminizip-dev,
  libpng-dev,
  libpulse-dev,
#  librcheevos-dev,
  libsdl2-dev,
  libshaderc-dev,
#  libsimpleini-dev,
  libsoundtouch-dev,
  libspirv-cross-c-shared-dev,
  libstb-dev,
  libtinyxml2-dev,
  libvulkan-dev,
  libvulkan-memory-allocator-dev,
  libwebp-dev,
  libxxhash-dev,
  libzstd-dev,
  libzydis-dev,
  qt6-base-private-dev (>= 6.7.2),
  qt6-tools-dev,
  rapidjson-dev,
  spirv-headers
Standards-Version: 4.7.0
Homepage: https://www.duckstation.org/

Package: duckstation
Architecture: amd64 arm64 armhf
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt6svg6, libshaderc1, duckstation-data (= ${source:Version})
Description: Sony PlayStation emulator
 DuckStation is an simulator/emulator of the Sony PlayStation(TM) console,
 focusing on playability, speed, and long-term maintainability.

Package: duckstation-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Suggests: duckstation
Description: Sony PlayStation emulator (data files)
 DuckStation is an simulator/emulator of the Sony PlayStation(TM) console,
 focusing on playability, speed, and long-term maintainability.
 .
 This package contains the platform independent data files for DuckStation.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

execute_before_dh_auto_build:
	cd obj-* && mkdir -p bin/resources/
